//
//  DBIDCardData.h
//  ble_nfc_sdk
//
//  Created by h_n on 2019/5/5.
//  Copyright © 2019年 Lochy. All rights reserved.
//

#import <Foundation/Foundation.h>

typedef NS_ENUM(NSInteger, DBIDCardType) {
    DBIDCardTypeCN = 1, //身份证类型-居民身份证
    DBIDCardTypeGAT = 2, //身份证类型-港澳台居民身份证
    DBIDCardTypeFOREIGN = 3 //身份证类型-外国人永久居留身份证
};

@interface DBIDCardData : NSObject

/** 证件类型*/
@property (nonatomic, assign) DBIDCardType type;

/** 姓名*/
@property (nonatomic, strong) NSString *fullName;
/** 身份号码*/
@property (nonatomic, strong) NSString *idNumber;
/** 性别*/
@property (nonatomic, strong) NSString *gener;

/** 地址*/
@property (nonatomic, strong) NSString *address;
/** 民族*/
@property (nonatomic, strong) NSString *nation;
/** 出生年月日*/
@property (nonatomic, strong) NSString *birthday;

/** 签发机关*/
@property (nonatomic, strong) NSString *grantDept;

/** 有效起始日期*/
@property (nonatomic, strong) NSString *startDate;
/** 有效截止日期*/
@property (nonatomic, strong) NSString *endDate;

/** 护照号*/
@property (nonatomic, strong) NSString *passport;

/** 签发次数*/
@property (nonatomic, strong) NSString *issueNumber;

/** 照片数据*/
@property (nonatomic, strong) NSData *imageData;

+ (instancetype)formatter:(NSData *)idCardData image:(NSData *)imageParam;
+ (NSString *)idCardDataToString:(DBIDCardData *)idCardData;

@end

