//
//  DBStreamDataTool.m
//  ble_nfc_sdk
//
//  Created by h_n on 2019/5/5.
//  Copyright © 2019年 Lochy. All rights reserved.
//

#import "DBStreamDataTool.h"
#import <CommonCrypto/CommonCrypto.h>
#import <CommonCrypto/CommonDigest.h>

@implementation DBStreamDataTool

+ (NSData *)mergeData:(NSData *)header source:(NSData *)source begin:(int)begin end:(int)end {
    NSMutableData *result = [[NSMutableData alloc] init];
    [result appendData:header];
    [result appendData:source];
    return result;
}

+ (NSData *)header:(int)headerLength {
    int temp = headerLength;
    Byte value = temp & 0xff;
    temp = temp >> 8;
    Byte length = temp & 0xff;
    Byte b[] = {value, length};
    NSData *header = [NSData dataWithBytes:b length:2];
    return header;
}

+ (int)dataLength:(NSData *)streamData {
    int length = 0;
    Byte *bytes = (Byte *)streamData.bytes;
    
    int s0 = bytes[0] & 0xff;
    int s1 = (bytes[1] & 0xff) << 8;
    length =  s1 | s0 + 2;
    
    return length;
}

//// 解密
//+ (NSData *)decryptDataWithData:(NSData *)data andKey:(NSString *)key {
//    char keyPtr[kCCKeySizeAES128 + 1];
//    bzero(keyPtr, sizeof(keyPtr));
//    [key getCString:keyPtr maxLength:sizeof(keyPtr) encoding:NSUTF8StringEncoding];
//    NSUInteger dataLength = [data length];
//    size_t bufferSize = dataLength + kCCBlockSizeAES128;
//    void *buffer = malloc(bufferSize);
//    size_t numBytesDecrypted = 0;
//    CCCryptorStatus cryptStatus = CCCrypt(kCCDecrypt, kCCAlgorithmAES128, kCCOptionPKCS7Padding | kCCOptionECBMode, keyPtr, kCCBlockSizeAES128, NULL, [data bytes], dataLength, buffer, bufferSize, &numBytesDecrypted);
//    
//    if(cryptStatus == kCCSuccess) {
//        return [NSData dataWithBytesNoCopy:buffer length:numBytesDecrypted];
//    }
//    free(buffer);
//    return nil;
//}
+ (NSData *)decryptDataWithData:(NSData *)data andKey:(NSData *)key {
//    char keyPtr[kCCKeySizeAES128 + 1];
//    bzero(keyPtr, sizeof(keyPtr));
    if (key.length != 16) {
        return nil;
    }
    
    char *keyPtr = (char *)key.bytes;
    NSUInteger dataLength = [data length];
    size_t bufferSize = dataLength + kCCBlockSizeAES128;
    void *buffer = malloc(bufferSize);
    size_t numBytesDecrypted = 0;
    CCCryptorStatus cryptStatus = CCCrypt(kCCDecrypt, kCCAlgorithmAES128, kCCOptionPKCS7Padding | kCCOptionECBMode, keyPtr, kCCBlockSizeAES128, NULL, [data bytes], dataLength, buffer, bufferSize, &numBytesDecrypted);
    
    if(cryptStatus == kCCSuccess) {
        return [NSData dataWithBytesNoCopy:buffer length:numBytesDecrypted];
    }
    free(buffer);
    return nil;
}

@end
