//
//  DKCloudID.h
//  ble_nfc_sdk
//
//  Created by lochy on 2019/5/7.
//  Copyright © 2019 Lochy. All rights reserved.
//

#import <Foundation/Foundation.h>

NS_ASSUME_NONNULL_BEGIN

typedef void(^onReceiveDataListener)(NSData* data);
typedef void(^connectServerSuccessListener)();

@interface DKCloudID : NSObject
@property (nonatomic,strong) NSInputStream *inputStream;      // 输入流,用来读取服务器返回的字节
@property (nonatomic,strong) NSOutputStream *outputStream;    // 输出流,用于给服务器发送字节
@property (nonatomic,assign) bool isWriteDataAvailable;       //是否可以发送数据

- (id)init;
- (void)connectToServer:(NSString *)host port:(NSInteger)port;
- (void)close;

/**
 * 发送数据到服务器，异步回调方式
 * @param sendData - 要发送到数据
 * @param block - 服务器返回到结果会回调到block
 */
- (void)sendPacket:(NSData *)sendData callBack:(onReceiveDataListener)block;

/**
 * 发送数据到服务器，同步阻塞方式
 * @param sendData - 要发送到数据
 * @param timeMs - 超时等待时间，单位ms
 * @throws DKServerException
 *                  数据接收超时时会抛出异常
 */
- (NSData *)sendPacket:(NSData *)sendData timeout:(int)timeMs;

@end

NS_ASSUME_NONNULL_END
