//
//  ViewController.m
//  ble_nfc_sdk
//
//  Created by sahmoL on 16/6/22.
//  Copyright © 2016年 Lochy. All rights reserved.
//

#import "ViewController.h"
#import "DKBleNfc.h"
#import "SZTCard.h"
#import "yangChengTongCard.h"
#import "NSData+Hex.h"
#import "DKBleManager.h"
#import "SamVIdCard.h"

#import "DBStreamDataTool.h"
#import "DBIDCardData.h"
#import "DKCloudID.h"

#define SEARCH_BLE_NAME   @"BLE_NFC"

@interface ViewController () <DKBleManagerDelegate, DKBleNfcDeviceDelegate>
@property (nonatomic, strong) DKBleManager     *bleManager;
//@property (nonatomic, strong) DKbleNfcDevice  *bleNfcDevice;
@property (nonatomic, strong) DKBleNfcDevice   *bleNfcDevice;
@property (nonatomic, strong) CBPeripheral     *mNearestBle;
@property (nonatomic, strong) UIButton         *doneButton;

@property (nonatomic, strong) NSMutableString  *msgBuffer;
@property (weak, nonatomic) IBOutlet UITextView *msgTextView;
@property (weak, nonatomic) IBOutlet UIButton *searchButton;


@property (nonatomic, strong) SamVIdCard *samVIdCard;

@end

@implementation ViewController
@synthesize bleManager;
@synthesize doneButton;
@synthesize bleNfcDevice;

NSInteger lastRssi = -100;
Byte      tradeN   = 1;
- (void)viewDidLoad {
    [super viewDidLoad];
    self.msgBuffer = [[NSMutableString alloc] init];
    lastRssi = -100;
    self.mNearestBle = nil;
    
    self.bleManager = [DKBleManager sharedInstance];
    self.bleManager.delegate = self;
    self.bleNfcDevice = [[DKBleNfcDevice alloc] initWithDelegate:self];
    [self.msgTextView setText:@"BLE_NFC Demo v2.0.0使用说明：\r\n1、点击搜索设备按键会自动搜索最近的蓝牙设备并连接上\r\n2、读取数据目前支持深圳通余额和交易记录读取、M1卡（S50/S70）卡扇区读写增加值、身份证相关信息读取、NFC标签（例如ntag21x）NDEF Text格式数据读取。读取方法：连接设备后，将卡片放到读卡区，然后点击读取数据按键即会自动读取\r\n3、写入数据按键针对NTAG21X系列和M1卡，如果是NTAG21x会将编辑区的文本以NDEF Text格式写入。写入方法：连接设备后，在此区域编辑文本，然后点击写入数据，等待写入完成。如果是M1卡则初始化块1为电子钱包，初始化金额10000\r\n4、打开防丢器功能蓝牙指示灯会免掉，如果断开连接，设备蜂鸣器会报警\r\n5、按键按下会显示是长按还是短按"];
    
    //设置设备按键监听
    [self.bleNfcDevice setOonReceiveButtonEnterListenerBlock:^(Byte keyValue) {
        if (keyValue == BUTTON_VALUE_SHORT_ENTER) { //按键短按
            [self.msgBuffer appendString:@"按键短按\r\n"];
            dispatch_async(dispatch_get_main_queue(), ^{
                self.msgTextView.text = self.msgBuffer;
            });
        }
        else if (keyValue == BUTTON_VALUE_LONG_ENTER) { //按键长按
            [_msgBuffer appendString:@"按键长按\r\n"];
            dispatch_async(dispatch_get_main_queue(), ^{
                self.msgTextView.text = self.msgBuffer;
            });
        }
    }];
    
    //添加键盘完成按键
    UIToolbar *topView = [[UIToolbar alloc] initWithFrame:CGRectMake(0, 0, 320, 30)];
    [topView setBarStyle:UIBarStyleDefault];
    UIBarButtonItem *myBn = [[UIBarButtonItem alloc] initWithTitle:@"" style:UIBarButtonItemStyleBordered target:self action:nil];
    UIBarButtonItem *spaceBn = [[UIBarButtonItem alloc] initWithBarButtonSystemItem:UIBarButtonSystemItemFlexibleSpace target:self action:nil];
    UIBarButtonItem *doneBn = [[UIBarButtonItem alloc] initWithTitle:NSLocalizedString(@"完成",nil) style:UIBarButtonItemStyleDone target:self action:@selector(hideKeyboard)];
    NSArray * buttonsArray = [NSArray arrayWithObjects:myBn,spaceBn,doneBn, nil];
    [topView setItems:buttonsArray];
    [self.msgTextView setInputAccessoryView:topView];
}

- (void)didReceiveMemoryWarning {
    [super didReceiveMemoryWarning];
    // Dispose of any resources that can be recreated.
}

-(void) hideKeyboard {
    [doneButton removeFromSuperview];
    [self.msgTextView resignFirstResponder];
    
}


//搜索、断开连接按键监听
- (IBAction)SearchButtonEnter:(id)sender {
    //如果已经连接设备，则断开连接设备，如果没有连接设备则开始搜索设备，搜到指定名字的设备后开始连接
    if ( [self.bleManager isConnect] ) {
        [self.searchButton setTitle:@"正在断开连接.." forState:UIControlStateNormal];
        self.msgTextView.text = @"正在断开连接..";
        [self.bleManager cancelConnect];
    }
    else {
        [self fineNearBle];
    }
}

//找到最近的ble设备并连接
-(void)fineNearBle{
    [self.searchButton setTitle:@"正在搜索设备.." forState:UIControlStateNormal];
    self.msgTextView.text = @"正在搜索设备..";
    self.mNearestBle = nil;
    lastRssi = -100;
    [self.bleManager startScan];
    dispatch_async(dispatch_get_global_queue(DISPATCH_QUEUE_PRIORITY_DEFAULT, 0), ^{
        int searchCnt = 0;
        while ((self.mNearestBle == nil) && (searchCnt++ < 5000) && ([self.bleManager isScanning])) {
            [NSThread sleepForTimeInterval:0.001f];
        }
        [NSThread sleepForTimeInterval:1.0f];
        [self.bleManager stopScan];
        if (self.mNearestBle == nil) {
            //开始连接设备
            dispatch_async(dispatch_get_main_queue(), ^{
                self.msgTextView.text = @"未找到设备！";
                [self.searchButton setTitle:@"搜索设备" forState:UIControlStateNormal];
            });
        }
        else{
            //开始连接设备
            dispatch_async(dispatch_get_main_queue(), ^{
                self.msgTextView.text = @"正在连接设备..";
            });
            [self.bleManager connect:self.mNearestBle callbackBlock:^(BOOL isConnectSucceed) {
                if (isConnectSucceed) {
                    //设备连接成功
                    dispatch_async(dispatch_get_main_queue(), ^{
                        [self.msgBuffer setString:@"设备连接成功！\r\n"];
                        self.msgTextView.text = self.msgBuffer;
                        self.searchButton.titleLabel.text = @"断开连接";
                        //获取设备信息
                        [self getDeviceMsg];
                    });
                }
                else {
                    //设备连接失败
                    dispatch_async(dispatch_get_main_queue(), ^{
                        self.msgTextView.text = @"设备已断开！";
                        self.searchButton.titleLabel.text = @"搜索设备";
                    });
                }
            }];
        }
    });
}

//获取设备信息
-(void)getDeviceMsg {
    dispatch_async(dispatch_get_global_queue(DISPATCH_QUEUE_PRIORITY_DEFAULT, 0), ^{
        @try {
            BOOL isSuc;
            
            //获取设备版本
            Byte versionNum = [self.bleNfcDevice getDeviceVersions];
            [self.msgBuffer appendString:@"SDK版本v2.1.0 20170612\r\n"];
            [self.msgBuffer appendString:[NSString stringWithFormat:@"设备版本：%02lx\r\n", (unsigned long)versionNum]];
            [self.msgBuffer appendString:@"蓝牙名称："];
            [self.msgBuffer appendString:[self.bleNfcDevice getDeviceName]];
            [self.msgBuffer appendString:[NSString stringWithFormat:@"\r\n信号强度：%lddB\r\n", (long)lastRssi]];
            dispatch_async(dispatch_get_main_queue(), ^{
                self.msgTextView.text = self.msgBuffer;
            });
            
//            //获取设备电池电压
//            float btVlueMv = [self.bleNfcDevice getDeviceBatteryVoltage];
//            [self.msgBuffer appendString:[NSString stringWithFormat:@"设备电池电压：%.2fV\r\n", btVlueMv]];
//            if (btVlueMv < 3.6) {
//                [self.msgBuffer appendString:@"设备电池电量低，请及时充电！\r\n"];
//            }
//            else {
//                [self.msgBuffer appendString:@"设备电池电量充足！\r\n"];
//            }
//            dispatch_async(dispatch_get_main_queue(), ^{
//                self.msgTextView.text = self.msgBuffer;
//            });
            
            //开启自动寻卡
            isSuc = [self.bleNfcDevice startAutoSearchCard:20 cardType:ISO14443_P4];
            if (isSuc) {
                [self.msgBuffer appendString:@"自动寻卡已开启，正在寻卡..\r\n"];
            }
            else {
                [self.msgBuffer appendString:@"不支持自动寻卡\r\n"];
            }
            dispatch_async(dispatch_get_main_queue(), ^{
                self.msgTextView.text = self.msgBuffer;
            });
            
            //设置使用蓝牙5模式传输
            isSuc = [self.bleNfcDevice setBle5Mode];
            if (isSuc) {
                [self.msgBuffer appendString:@"设置蓝牙5传输模式成功！\r\n"];
            }
            else {
                [self.msgBuffer appendString:@"设置蓝牙5传输模式失败！\r\n"];
            }
            dispatch_async(dispatch_get_main_queue(), ^{
                self.msgTextView.text = self.msgBuffer;
            });
        } @catch (NSException *exception) {
            [self.msgBuffer appendString:exception.reason];
            dispatch_async(dispatch_get_main_queue(), ^{
                self.msgTextView.text = self.msgBuffer;
            });
        } @finally {
        }
    });
}

//读写卡Demo
-(BOOL)readWriteDemo:(DKCardType)cardType{
    switch (cardType) {
        case DKIso14443A_CPUType: {   //iso14443-a cpu卡
            CpuCard *cpuCard = [self.bleNfcDevice getCard];
            if (cpuCard != nil) {
                [self.msgBuffer setString:@"寻到iso14443A cpu卡 －>UID:"];
                [self.msgBuffer appendString:[NSString stringWithFormat:@"%@\r\n", cpuCard.uid]];
                dispatch_async(dispatch_get_main_queue(), ^{
                    self.msgTextView.text = self.msgBuffer;
                });
                
                //选择交易文件
                NSData *apduRtnData = [cpuCard cpuCardTransceive:[SZTCard getSelectMainFileCmdByte]];
                Byte *apduRtnBytes = (Byte *)[apduRtnData bytes];
                if ( (apduRtnData == nil)
                    || (apduRtnData.length <= 2)
                    || (apduRtnBytes[apduRtnData.length - 2] != (Byte)0x90)
                    || (apduRtnBytes[apduRtnData.length - 1] != (Byte)0x00)) {
                    [self.msgBuffer appendString:[NSString stringWithFormat:@"未知cpu卡\r\n"]];
                    dispatch_async(dispatch_get_main_queue(), ^{
                        self.msgTextView.text = self.msgBuffer;
                    });
                    
                    return NO;
                }
                
                apduRtnData = [cpuCard cpuCardTransceive:[SZTCard getBalanceCmdByte]];
                [self.msgBuffer appendString:@"余额："];
                [self.msgBuffer appendString:[SZTCard getBalance:apduRtnData]];
                dispatch_async(dispatch_get_main_queue(), ^{
                    self.msgTextView.text = self.msgBuffer;
                });
                
                //读10条交易记录
                for (int i=1; i<=10; i++) {
                    apduRtnData = [cpuCard cpuCardTransceive:[SZTCard getTradeCmdByte:(Byte)i]];
                    NSString *tradeString = [SZTCard getTrade:apduRtnData];
                    if (tradeString != nil) {
                        [self.msgBuffer appendString:@"\r\n"];
                        [self.msgBuffer appendString:tradeString];
                        dispatch_async(dispatch_get_main_queue(), ^{
                            self.msgTextView.text = self.msgBuffer;
                        });
                    }
                }
            }
        }
        break;
        
        case DKIso14443B_CPUType: {  //iso14443-b cpu卡
            Iso14443bCard *iso14443bcard = [self.bleNfcDevice getCard];
            if (iso14443bcard != nil) {
                [self.msgBuffer setString:@"寻到iso14443B cpu卡\r\n"];
                dispatch_async(dispatch_get_main_queue(), ^{
                    self.msgTextView.text = self.msgBuffer;
                });
                
//                [self.msgBuffer appendString:[NSString stringWithFormat:@"\r\n发送0084000008指令\r\n"]];
//                dispatch_async(dispatch_get_main_queue(), ^{
//                    self.msgTextView.text = self.msgBuffer;
//                });
//                Byte bytes[] = {0x00, (Byte)0x84, 0x00, 0x00, 0x08};
//                NSData *sendData = [NSData dataWithBytes:bytes length:5];
//                NSData *returnData = [iso14443bcard iso14443bCardTransceive:sendData];
//                if (returnData != nil) {
//                    [self.msgBuffer appendString:[NSString stringWithFormat:@"返回:%@\r\n", returnData]];
//                    dispatch_async(dispatch_get_main_queue(), ^{
//                        self.msgTextView.text = self.msgBuffer;
//                    });
//                }
                
                DKCloudID *dkCloudID = [[DKCloudID alloc] init];
                if (dkCloudID) {
                    @try {
                        self.samVIdCard = [[SamVIdCard alloc] init:self.bleNfcDevice];
                        NSData *samVInitData = [self.samVIdCard getSamVInitData];
                        
                        NSLog(@"向服务器发送数据：%@", samVInitData);
                        NSData *serverReturnData = [dkCloudID sendPacket:samVInitData timeout:3000];
                        NSLog(@"接收到服务器返回数据：%@", serverReturnData);
                        [self.msgBuffer setString:@"正在解析:1%"];
                        dispatch_async(dispatch_get_main_queue(), ^{
                            self.msgTextView.text = self.msgBuffer;
                        });
                        
                        NSData *nfcReturnData = nil;
                        int schedule = 1;
                        while (1) {
                            if (serverReturnData == nil) {
                                [self.msgBuffer setString:@"解析出错"];
                                dispatch_async(dispatch_get_main_queue(), ^{
                                    self.msgTextView.text = self.msgBuffer;
                                });
                                return NO;
                            }
                            else if (serverReturnData.length > 300) {
                                NSRange range = NSMakeRange(3, serverReturnData.length - 3);
                                NSData *result = [serverReturnData subdataWithRange:range];
                                NSLog(@"解密后到数据：%@", result);
                                
//                                //获取照片
//                                Byte* samVInitBytes = (Byte *)samVInitData.bytes;
//                                samVInitBytes[0] = (Byte)0xA0;
//                                samVInitData = [[NSData alloc] initWithBytes:samVInitBytes length:samVInitData.length];
//
//                                DKCloudID *dkCloudIDPitrue = [[DKCloudID alloc] init];
//                                serverReturnData = [dkCloudIDPitrue sendPacket:samVInitData timeout:3000];
//                                [dkCloudIDPitrue close];
//                                if ((serverReturnData == nil) || (serverReturnData.length < 4)) {
//                                    [self.msgBuffer setString:@"获取图片失败"];
//                                    dispatch_async(dispatch_get_main_queue(), ^{
//                                        self.msgTextView.text = self.msgBuffer;
//                                    });
//                                    return NO;
//                                }
//                                range = NSMakeRange(3, serverReturnData.length - 3);
//                                serverReturnData = [serverReturnData subdataWithRange:range];
                                
                                DBIDCardData *card = [DBIDCardData formatter:result image:samVInitData];
                                if (card != nil) {
                                    [self.msgBuffer setString:@"解析成功\r\n"];
                                    [self.msgBuffer appendString:[DBIDCardData idCardDataToString:card]];
                                    dispatch_async(dispatch_get_main_queue(), ^{
                                        self.msgTextView.text = self.msgBuffer;
                                    });

                                    NSTextAttachment *attachment = [[NSTextAttachment alloc] init];
                                    attachment.image = [UIImage imageWithData:card.imageData];
                                    
                                    dispatch_async(dispatch_get_main_queue(), ^{
                                        NSAttributedString *attributed = [NSAttributedString attributedStringWithAttachment:attachment];

                                        [self.msgBuffer appendString:@"\r\n"];
                                        NSMutableAttributedString *attributedString = [[NSMutableAttributedString alloc] initWithString:self.msgBuffer];
                                        [attributedString appendAttributedString:attributed];

                                        self.msgTextView.attributedText = attributedString;
                                    });
                                    return YES;
                                }
                                else {
                                    [self.msgBuffer setString:@"解析出错"];
                                    dispatch_async(dispatch_get_main_queue(), ^{
                                        self.msgTextView.text = self.msgBuffer;
                                    });
                                    return NO;
                                }
                                break;
                            }
                            
                            nfcReturnData = [self.samVIdCard samVIdCardtransceive:serverReturnData];
                            if (nfcReturnData == nil) {
                                [self.msgBuffer setString:@"解析出错"];
                                dispatch_async(dispatch_get_main_queue(), ^{
                                    self.msgTextView.text = self.msgBuffer;
                                });
                                return NO;
                            }
                            else if ((nfcReturnData != nil) && (nfcReturnData.length == 2)) {
                                Byte *nfcReturnBytes = (Byte *)[nfcReturnData bytes];
                                int errCord = ((nfcReturnBytes[0] & 0xff) << 8) | (nfcReturnBytes[1] & 0xff);
                                [self.msgBuffer setString:[NSString stringWithFormat:@"解析出错：%d", errCord]];
                                dispatch_async(dispatch_get_main_queue(), ^{
                                    self.msgTextView.text = self.msgBuffer;
                                });
                                return NO;
                            }
                            
                            NSLog(@"向服务器发送数据：%@", nfcReturnData);
                            serverReturnData = [dkCloudID sendPacket:nfcReturnData timeout:3000];
                            NSLog(@"接收到服务器返回数据：%@", serverReturnData);
                            [self.msgBuffer setString:[NSString stringWithFormat:@"正在解析%%%d", (int)((++schedule) * 100 / 45.0)]];
                            dispatch_async(dispatch_get_main_queue(), ^{
                                self.msgTextView.text = self.msgBuffer;
                            });
                        }
                    }@catch (NSException *exception) {
                        [self.msgBuffer appendString: [exception reason]];
                        dispatch_async(dispatch_get_main_queue(), ^{
                            self.msgTextView.text = self.msgBuffer;
                        });
                        
                        return NO;
                    }@finally {
                        [dkCloudID close];
                    }
                }
                
//                // 将samVInitData通过socket解析
//                [self connectToServer:socketHost port:socketPort success:^{
//                    NSData *header = [DBStreamDataTool header:samVInitData.length];
//                    NSData *body = [DBStreamDataTool mergeData:header source:samVInitData begin:0 end:0];
//                    [outputStream write:body.bytes maxLength:body.length];
//                }];
            }
        }
        break;
        
        case DKFeliCa_Type:
        
        break;
        
        case DKMifare_Type: {  //M1卡
            Mifare *mifare = [self.bleNfcDevice getCard];
            if (mifare != nil) {
                [self.msgBuffer setString:@"寻到M1卡 －>UID:"];
                [self.msgBuffer appendString:[NSString stringWithFormat:@"%@\r\n", mifare.uid]];
                dispatch_async(dispatch_get_main_queue(), ^{
                    self.msgTextView.text = self.msgBuffer;
                });
                Byte keybytes[] = {(Byte) 0xff, (Byte) 0xff,(Byte) 0xff,(Byte) 0xff,(Byte) 0xff,(Byte) 0xff};
                NSData *keyData = [[NSData alloc] initWithBytes:keybytes length:6];
                [self.msgBuffer appendString:@"使用默认密码（ffffffffffff）验证第1块密码\r\n"];
                dispatch_async(dispatch_get_main_queue(), ^{
                    self.msgTextView.text = self.msgBuffer;
                });
                //验证密码
                BOOL isSuc = [mifare mifareAuthenticate:1 keyType:MIFARE_KEY_TYPE_A key:keyData];
                if (!isSuc) {
                    [self.msgBuffer appendString:@"密码验证失败，密码错误！\r\n"];
                    dispatch_async(dispatch_get_main_queue(), ^{
                        self.msgTextView.text = self.msgBuffer;
                    });
                    return NO;
                }
                
                [self.msgBuffer appendString:@"密码验证成功\r\n"];
                [self.msgBuffer appendString:@"开始向块1写入数据:00112233445566778899aabbccddeeff\r\n"];
                dispatch_async(dispatch_get_main_queue(), ^{
                    self.msgTextView.text = self.msgBuffer;
                });
                
                Byte writeBytes[] = {0x00, 0x11, 0x22, 0x33, 0x44, 0x55,
                    0x66, 0x77, (Byte)0x88, (Byte)0x99, (Byte)0xaa,
                    (Byte)0xbb, (Byte)0xcc, (Byte)0xdd, (Byte)0xee, (Byte)0xff};
                isSuc = [mifare mifareWrite:1 data:[NSData dataWithBytes:writeBytes length:16]];
                if (!isSuc) {
                    [self.msgBuffer appendString:@"写入失败\r\n"];
                }
                else {
                    [self.msgBuffer appendString:@"写入成功\r\n"];
                }
                [self.msgBuffer appendString:@"开始读块1数据\r\n"];
                dispatch_async(dispatch_get_main_queue(), ^{
                    self.msgTextView.text = self.msgBuffer;
                });
                
                //读一个块
                NSData *readData = [mifare mifareRead:1];
                if ( (readData != nil) && (readData.length == 16) ) {
                    [self.msgBuffer appendString:[NSString stringWithFormat:@"读块1数据成功：%@", readData]];
                }
                else {
                    [self.msgBuffer appendString:@"读块失败\r\n"];
                }
                dispatch_async(dispatch_get_main_queue(), ^{
                    self.msgTextView.text = self.msgBuffer;
                });
                
            }
        }
        
        break;
        
        case DKIso15693_Type: {
            Iso15693Card *iso15693Card = [self.bleNfcDevice getCard];
            if (iso15693Card != nil) {
                [self.msgBuffer setString:@"寻到ISO15693卡 －>UID:"];
                [self.msgBuffer appendString:[NSString stringWithFormat:@"%@\r\n", iso15693Card.uid]];
                dispatch_async(dispatch_get_main_queue(), ^{
                    self.msgTextView.text = self.msgBuffer;
                });
                
                
                [self.msgBuffer appendString:@"写数据01020304到块0"];
                dispatch_async(dispatch_get_main_queue(), ^{
                    self.msgTextView.text = self.msgBuffer;
                });
                Byte writeBytes[] = {0x01, 0x02, 0x03, 0x04};
                BOOL isSuc = [iso15693Card iso15693Write:0 writeData:[NSData dataWithBytes:writeBytes length:4]];
                if (!isSuc) {
                    [self.msgBuffer appendString:@"写入失败\r\n"];
                }
                else {
                    [self.msgBuffer appendString:@"写入成功\r\n"];
                }
                [self.msgBuffer appendString:@"开始读块0\r\n"];
                dispatch_async(dispatch_get_main_queue(), ^{
                    self.msgTextView.text = self.msgBuffer;
                });
                //读取卡片0块数据
                NSData *returnData = [iso15693Card iso15693Read:0];
                [self.msgBuffer appendString:[NSString stringWithFormat:@"返回:%@\r\n", returnData]];
                dispatch_async(dispatch_get_main_queue(), ^{
                    self.msgTextView.text = self.msgBuffer;
                });
                
                //写多个块
                [self.msgBuffer appendString:@"写数据0102030405060708到块5、6"];
                dispatch_async(dispatch_get_main_queue(), ^{
                    self.msgTextView.text = self.msgBuffer;
                });
                Byte writeBytes1[] = {0x01, 0x02, 0x03, 0x04, 0x05, 0x06, 0x07, 0x08};
                isSuc = [iso15693Card iso15693WriteMultiple:5 number:2 writeData:[NSData dataWithBytes:writeBytes1 length:8]];
                if (!isSuc) {
                    [self.msgBuffer appendString:@"写入失败\r\n"];
                }
                else {
                    [self.msgBuffer appendString:@"写入成功\r\n"];
                }
                [self.msgBuffer appendString:@"开始读块5、6数据\r\n"];
                dispatch_async(dispatch_get_main_queue(), ^{
                    self.msgTextView.text = self.msgBuffer;
                });
                //读多个块
                returnData = [iso15693Card iso15693ReadMultiple:5 number:2];
                [self.msgBuffer appendString:[NSString stringWithFormat:@"返回:%@\r\n", returnData]];
                dispatch_async(dispatch_get_main_queue(), ^{
                    self.msgTextView.text = self.msgBuffer;
                });
            }
        }
        
        break;
        
        case DKUltralight_type: {//UL卡
            Ntag21x *ntag21x = [self.bleNfcDevice getCard];
            if (ntag21x != nil) {
                [self.msgBuffer setString:@"寻到Ultralight卡 －>UID:"];
                [self.msgBuffer appendString:[NSString stringWithFormat:@"%@\r\n", ntag21x.uid]];
                [self.msgBuffer appendString:@"正在写入888个字节数据0xaa到卡片...\r\n"];
                dispatch_async(dispatch_get_main_queue(), ^{
                    self.msgTextView.text = self.msgBuffer;
                });
                
                //开始写200字节数据到卡片
                Byte writeBytes[888];
                memset(writeBytes, 0xAA, sizeof(writeBytes));
                BOOL isSuc = [ntag21x ntag21xLongWrite:4 writeData:[NSData dataWithBytes:writeBytes length:sizeof(writeBytes)]];
                if (!isSuc) {
                    [self.msgBuffer appendString:@"写入失败\r\n"];
                }
                else {
                    [self.msgBuffer appendString:@"写入成功\r\n"];
                }
                [self.msgBuffer appendString:@"开始读888个字数据\r\n"];
                dispatch_async(dispatch_get_main_queue(), ^{
                    self.msgTextView.text = self.msgBuffer;
                });
                
                NSData *readData = [ntag21x ntag21xLongRead:4 endAddress:800/4];
                [self.msgBuffer appendString:[NSString stringWithFormat:@"返回:%@\r\n", readData]];
                dispatch_async(dispatch_get_main_queue(), ^{
                    self.msgTextView.text = self.msgBuffer;
                });
            }
        }
        break;
        
        case DKDESFire_type:
        
        break;
        
        default:
        break;
    }
    
    return YES;
}

//发送指令
- (IBAction)readWriteButton:(id)sender {
    if ( ![self.bleManager isConnect] ) {
        self.msgTextView.text = @"设备未连接！请先连接设备！";
        return;
    }
    
    //寻卡一次
    [self.bleNfcDevice requestRfmSearchCard:DKCardTypeDefault callbackBlock:nil];
}

//修改蓝牙名称
- (IBAction)changeBleNameButton:(id)sender {
    if ( ![self.bleManager isConnect] ) {
        self.msgTextView.text = @"设备未连接！请先连接设备！";
        return;
    }
    
    UIAlertController *alertController = [UIAlertController alertControllerWithTitle:@"修改蓝牙名称" message:@"请输入蓝牙名称" preferredStyle:UIAlertControllerStyleAlert];
    
    // 创建文本框
    [alertController addTextFieldWithConfigurationHandler:^(UITextField *textField){
        textField.placeholder = @"BLE NAME";
        textField.secureTextEntry = NO;
    }];
    
    UIAlertAction *cancelAction = [UIAlertAction actionWithTitle:@"取消" style:UIAlertActionStyleCancel handler:^(UIAlertAction *action) {
    }];
    UIAlertAction *okAction = [UIAlertAction actionWithTitle:@"确定" style:UIAlertActionStyleDefault handler:^(UIAlertAction *action) {
        // 读取文本框的值显示出来
        UITextField *bleNameTextField = alertController.textFields.firstObject;
        NSString *bleNameStr = bleNameTextField.text;
        dispatch_async(dispatch_get_global_queue(DISPATCH_QUEUE_PRIORITY_DEFAULT, 0), ^{
            @try {
                BOOL isSuc = [self.bleNfcDevice changeBleName:bleNameStr];
                if (!isSuc) {
                    [self.msgBuffer appendString:@"修改蓝牙名称失败！\r\n"];
                }
                else {
                    [self.msgBuffer appendString:@"修改蓝牙名称成功，重启设备后生效！\r\n"];
                }
                dispatch_async(dispatch_get_main_queue(), ^{
                    self.msgTextView.text = self.msgBuffer;
                });
            } @catch (NSException *exception) {
                [self.msgBuffer appendString:[exception reason]];
                dispatch_async(dispatch_get_main_queue(), ^{
                    self.msgTextView.text = self.msgBuffer;
                });
            } @finally {}
        });
    }];
    
    [alertController addAction:cancelAction];
    [alertController addAction:okAction];
    
    [self presentViewController:alertController animated:NO completion:nil];
}

//清空显示按键监听
- (IBAction)clearDisplayButton:(id)sender {
    [self.msgBuffer setString:@""];
    self.msgTextView.text = self.msgBuffer;
}

//打开蜂鸣器按键
- (IBAction)openBeepButton:(id)sender {
    if ( ![self.bleManager isConnect] ) {
        self.msgTextView.text = @"设备未连接！请先连接设备！";
        return;
    }
    
    [self.bleNfcDevice requestOpenBeep:50 offDelay:100 number:200 callback:^(BOOL isSuc) {
        if (isSuc) {
            [self.msgBuffer setString:@"打开蜂鸣器成功！\r\n"];
            self.msgTextView.text = self.msgBuffer;
        }
    }];
}
//关闭蜂鸣器按键
- (IBAction)closeBeepButton:(id)sender {
    if ( ![self.bleManager isConnect] ) {
        self.msgTextView.text = @"设备未连接！请先连接设备！";
        return;
    }
    
    [self.bleNfcDevice requestOpenBeep:0 offDelay:0 number:0 callback:^(BOOL isSuc) {
        if (isSuc) {
            [self.msgBuffer setString:@"关闭蜂鸣器成功！\r\n"];
            self.msgTextView.text = self.msgBuffer;
        }
    }];
}
//打开防丢器功能按键
- (IBAction)openAnti_lostButton:(id)sender {
    if ( ![self.bleManager isConnect] ) {
        self.msgTextView.text = @"设备未连接！请先连接设备！";
        return;
    }
    
    [self.bleNfcDevice requestAntiLostSwitch:YES callback:^(BOOL isSuc) {
        if (isSuc) {
            [self.msgBuffer setString:@"打开防丢器功能成功！\r\n"];
            self.msgTextView.text = self.msgBuffer;
        }
    }];
}
//关闭防丢器功能按键
- (IBAction)closeAnti_lostButton:(id)sender {
    if ( ![self.bleManager isConnect] ) {
        self.msgTextView.text = @"设备未连接！请先连接设备！";
        return;
    }
    
    [self.bleNfcDevice requestAntiLostSwitch:NO callback:^(BOOL isSuc) {
        if (isSuc) {
            [self.msgBuffer setString:@"关闭防丢器功能成功！\r\n"];
            self.msgTextView.text = self.msgBuffer;
        }
    }];
}

//开始自动寻卡
- (IBAction)startAutoSearCardButton:(id)sender {
    if ( ![self.bleManager isConnect] ) {
        self.msgTextView.text = @"设备未连接！请先连接设备！";
        return;
    }
    
    dispatch_async(dispatch_get_global_queue(DISPATCH_QUEUE_PRIORITY_DEFAULT, 0), ^{
        @try {
            //开启自动寻卡
            BOOL isSuc = [self.bleNfcDevice startAutoSearchCard:20 cardType:ISO14443_P4];
            if (isSuc) {
                [self.msgBuffer appendString:@"自动寻卡已开启，正在寻卡..\r\n"];
            }
            else {
                [self.msgBuffer appendString:@"不支持自动寻卡\r\n"];
            }
            dispatch_async(dispatch_get_main_queue(), ^{
                self.msgTextView.text = self.msgBuffer;
            });
        } @catch (NSException *exception) {
            [self.msgBuffer appendString:[exception reason]];
            dispatch_async(dispatch_get_main_queue(), ^{
                self.msgTextView.text = self.msgBuffer;
            });
        } @finally {}
    });
}

//停止自动寻卡
- (IBAction)stopAutoSearchCard:(id)sender {
    if ( ![self.bleManager isConnect] ) {
        self.msgTextView.text = @"设备未连接！请先连接设备！";
        return;
    }
    
    dispatch_async(dispatch_get_global_queue(DISPATCH_QUEUE_PRIORITY_DEFAULT, 0), ^{
        @try {
            //开启自动寻卡
            BOOL isSuc = [self.bleNfcDevice stoptAutoSearchCard];
            if (isSuc) {
                [self.msgBuffer appendString:@"自动寻卡已开启，正在寻卡..\r\n"];
            }
            else {
                [self.msgBuffer appendString:@"自动寻卡已关闭！\r\n"];
            }
            dispatch_async(dispatch_get_main_queue(), ^{
                self.msgTextView.text = self.msgBuffer;
            });
        } @catch (NSException *exception) {
            [self.msgBuffer appendString:[exception reason]];
            dispatch_async(dispatch_get_main_queue(), ^{
                self.msgTextView.text = self.msgBuffer;
            });
        } @finally {
        }
    });
}

//读到卡片代理回调
#pragma mark - DKBleNfcDeviceDelegate
-(void)receiveRfnSearchCard:(BOOL)isblnIsSus cardType:(DKCardType)cardType uid:(NSData *)CardSn ats:(NSData *)bytCarATS{
    [self.msgBuffer appendString:@"寻到卡片："];
    [self.msgBuffer appendString:[CardSn description]];
    [self.msgBuffer appendString:@"\r\n"];
    [self.msgTextView setText:self.msgBuffer];
    
    
    dispatch_async(dispatch_get_global_queue(DISPATCH_QUEUE_PRIORITY_DEFAULT, 0), ^{
        BOOL isAutoSearchCardFlag = [self.bleNfcDevice isAutoSearchCard];
        
        @try {
            BOOL isSuc = NO;
            //如果是自动寻卡寻到的卡，寻到卡后，先关闭自动寻卡
            if (isAutoSearchCardFlag) {
                //先关掉自动寻卡
                [self.bleNfcDevice stoptAutoSearchCard];
                
                //开始读卡
                isSuc = [self readWriteDemo:cardType];
                
                //读写卡成功，蜂鸣器快响3声
                if (isSuc) {
                    [self.bleNfcDevice openBeep:50 offDelay:50 cnt:3];
                }
                else {
                    //[self.bleNfcDevice openBeep:100 offDelay:100 cnt:2];
                    
                    //读卡失败，重新读卡
                    [self.bleNfcDevice closeRf];
                }
                
                //读卡结束，重新打开自动寻卡
                int cnt = 0;
                BOOL autoSearchCardFlag;
                do {
                    autoSearchCardFlag = [self.bleNfcDevice startAutoSearchCard:20 cardType:ISO14443_P4];
                }while (!autoSearchCardFlag && (cnt++ < 3));
                
                if (!autoSearchCardFlag) {
                    [self.msgBuffer appendString:[NSString stringWithFormat:@"不支持自动寻卡！\r\n"]];
                    dispatch_async(dispatch_get_main_queue(), ^{
                        self.msgTextView.text = self.msgBuffer;
                    });
                }
            }
            else {
                //开始读卡
                isSuc = [self readWriteDemo:cardType];
                
                //如果不是自动寻卡，读卡结束,关闭天线
                [self.bleNfcDevice closeRf];
                
                //读写卡成功，蜂鸣器快响3声
                if (isSuc) {
                    [self.bleNfcDevice openBeep:50 offDelay:50 cnt:3];
                }
                else {
                    [self.bleNfcDevice openBeep:100 offDelay:100 cnt:2];
                }
            }
        } @catch (NSException *exception) {
            [self.msgBuffer appendString:[exception reason]];
            dispatch_async(dispatch_get_main_queue(), ^{
                self.msgTextView.text = self.msgBuffer;
            });
            //[self.bleNfcDevice openBeep:100 offDelay:100 cnt:2];
            
            if (isAutoSearchCardFlag) {
                //读卡失败，重新打开自动寻卡
                int cnt = 0;
                BOOL autoSearchCardFlag;
                do {
                    @try {
                        autoSearchCardFlag = [self.bleNfcDevice startAutoSearchCard:20 cardType:ISO14443_P4];
                    }@catch (NSException *exception) {
                        autoSearchCardFlag = false;
                    }
                }while (!autoSearchCardFlag && (cnt++ < 3));
                
                if (!autoSearchCardFlag) {
                    [self.msgBuffer appendString:[NSString stringWithFormat:@"不支持自动寻卡！\r\n"]];
                    dispatch_async(dispatch_get_main_queue(), ^{
                        self.msgTextView.text = self.msgBuffer;
                    });
                }
            }
        } @finally {
        }
    });
}

/*
 * 函数说明：蓝牙搜索回调
 */
#pragma mark - DKBleManagerDelegate
-(void)DKScannerCallback:(CBCentralManager *)central didDiscoverPeripheral:(CBPeripheral *)peripheral advertisementData:(NSDictionary *)advertisementData RSSI:(NSNumber *)RSSI {
    
    NSData *facturerData = [advertisementData objectForKey:@"kCBAdvDataManufacturerData"];
    NSData *uuidData = [advertisementData objectForKey:@"kCBAdvDataServiceUUIDs"];
    Byte *facturerDataBytes = (Byte *) [facturerData bytes];
    NSLog(@"rssi:%@ 工厂信息字段：%@ name:%@", RSSI, facturerData, peripheral.name);
    if ([RSSI integerValue] < -55) {
        return;
    }
    
    //if ([peripheral.name isEqualToString:SEARCH_BLE_NAME]) {
    //通过广播数据过滤蓝牙设备
    if ( (facturerData != nil)
        && (facturerData.length >= 4)
        && (facturerDataBytes[0] == 0x01)
        && (facturerDataBytes[1] == 0x7f)
        && (facturerDataBytes[2] == 0x54)
        && (facturerDataBytes[3] == 0x50)) {
            NSLog(@"搜到设备：%@ %@", peripheral, RSSI);
            if (self.mNearestBle != nil) {
                if ([RSSI integerValue] > lastRssi) {
                    self.mNearestBle = peripheral;
                }
            }
            else {
                self.mNearestBle = peripheral;
                lastRssi = [RSSI integerValue];
            }
        }
//    if ( (facturerData != nil)
//        && (facturerData.length >= 5)
//        && (facturerDataBytes[0] == 'D')
//        && (facturerDataBytes[1] == 'A')
//        && (facturerDataBytes[2] == 'B')
//        && (facturerDataBytes[3] == 'B')
//        && (facturerDataBytes[4] == 'Y')
//        ) {
//        NSLog(@"搜到设备：%@ %@", peripheral, RSSI);
//        if (self.mNearestBle != nil) {
//            if ([RSSI integerValue] > lastRssi) {
//                self.mNearestBle = peripheral;
//            }
//        }
//        else {
//            self.mNearestBle = peripheral;
//            lastRssi = [RSSI integerValue];
//        }
//    }
}

/*
 * 函数说明：蓝牙状态回调
 */
#pragma mark - DKBleManagerDelegate
-(void)DKCentralManagerDidUpdateState:(CBCentralManager *)central {
    NSError *error = nil;
    switch (central.state) {
        case CBCentralManagerStatePoweredOn://蓝牙打开
        {
            //开始搜索设备
            [self fineNearBle];
        }
            break;
        case CBCentralManagerStatePoweredOff://蓝牙关闭
        {
            error = [NSError errorWithDomain:@"CBCentralManagerStatePoweredOff" code:-1 userInfo:nil];
        }
            break;
        case CBCentralManagerStateResetting://蓝牙重置
        {
            //pendingInit = YES;
        }
            break;
        case CBCentralManagerStateUnknown://未知状态
        {
            error = [NSError errorWithDomain:@"CBCentralManagerStateUnknown" code:-1 userInfo:nil];
        }
            break;
        case CBCentralManagerStateUnsupported://设备不支持
        {
            error = [NSError errorWithDomain:@"CBCentralManagerStateUnsupported" code:-1 userInfo:nil];
        }
            break;
        default:
            break;
    }
}

//蓝牙连接状态回调
-(void)DKCentralManagerConnectState:(CBCentralManager *)central state:(BOOL)state{
    if (state) {
        NSLog(@"蓝牙连接成功");
    }
    else {
        NSLog(@"蓝牙连接失败");
        dispatch_async(dispatch_get_main_queue(), ^{
            self.msgTextView.text = @"设备已断开！";
            self.searchButton.titleLabel.text = @"搜索设备";
        });
    }
}

@end
