//
//  SamVIdCard.h
//  ble_nfc_sdk
//
//  Created by lochy on 2019/4/24.
//  Copyright © 2019 Lochy. All rights reserved.
//

#import "Card.h"

NS_ASSUME_NONNULL_BEGIN

@interface SamVIdCard : Card

/**
 * 获取解析初始化数据，同步阻塞方式，注意：不能在主线程里运行
 * @return         返回解析初始化数据
 * @throws CardNoResponseException
 *                  操作无响应时会抛出异常
 */
-(NSData *)getSamVInitData;

/**
 * 获取解析结束后用于解密明文的aeskey，同步阻塞方式，注意：不能在主线程里运行
 * @return         返回的aes key，16字节
 * @throws CardNoResponseException
 *                  操作无响应时会抛出异常
 */
-(NSData *)getSamVAesKeyData;

/**
 * 解析过程交互，注意：不能在蓝牙初始化的线程里运行
 * @param data     发送的数据
 * @return         返回的数据
 * @throws CardNoResponseException
 *                  操作无响应时会抛出异常
 */
-(NSData *)samVIdCardtransceive:(NSData *)data;

@end

NS_ASSUME_NONNULL_END
